from .album import Album
from .artist import Artist
from .file import File
from .playlist import Playlist
from .title import Title


class Entry:
    def __init__(
        self,
        title: Title,
        artist: Artist,
        duration: int,
        thumbnail: str,
        requesterId: int,
        album: Album | None = None,
        playlist: Playlist | None = None,
        source: File | str | None = None,
    ) -> None:
        self.title = title
        self.artist = artist
        self.album = album
        self.duration = duration
        self.thumbnail = thumbnail
        self.requester = requesterId
        self.playlist = playlist
        self.source = source
